package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLOptions_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLOptions extends JNIObject  {
	
	/* @generated */
	protected ISLOptions(long ptr) {
		/*** PROTECTED REGION ID(ISLOptions_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLOptions build(long ptr) {
		return new ISLOptions(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLOptions_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	/*************************************** 
	 *	     Struct Field Accessors        * 
	 ***************************************/
	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_options_new_with_defaults 
	 * 
	 * @generated
	**/
	 public static ISLOptions islOptionsNewWithDefaults() { 
		/*** PROTECTED REGION ID(static_isl_options_new_with_defaults) DISABLED START ***/
		ISLOptions res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLOptions.build(ISLNative.isl_options_new_with_defaults());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_coalesce_bounded_wrapping 
	 * 
	 * @generated
	**/
	 public static int getCoalesceBoundedWrapping(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_coalesce_bounded_wrapping) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_coalesce_bounded_wrapping(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_coalesce_bounded_wrapping 
	 * 
	 * @generated
	**/
	 public static int setCoalesceBoundedWrapping(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_coalesce_bounded_wrapping) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_coalesce_bounded_wrapping(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_tile_scale_tile_loops 
	 * 
	 * @generated
	**/
	 public static int setTileScaleTileLoops(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_tile_scale_tile_loops) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_tile_scale_tile_loops(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_tile_scale_tile_loops 
	 * 
	 * @generated
	**/
	 public static int getTileScaleTileLoops(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_tile_scale_tile_loops) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_tile_scale_tile_loops(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_tile_shift_point_loops 
	 * 
	 * @generated
	**/
	 public static int setTileShiftPointLoops(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_tile_shift_point_loops) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_tile_shift_point_loops(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_tile_shift_point_loops 
	 * 
	 * @generated
	**/
	 public static int getTileShiftPOintLoops(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_tile_shift_point_loops) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_tile_shift_point_loops(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLOptions_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
